<template>
  <div class="app-container">
    <el-form :model="queryParams" @submit.native.prevent ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item :label="$t('分类名称')" prop="itemTypeName">
        <el-input
          v-model="queryParams.itemTypeName"
         
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('是否启用')" prop="enableFlag">
        <el-select v-model="queryParams.enableFlag" clearable>
          <el-option
            v-for="dict in dict.type.sys_yes_no"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('common.search') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('common.reset') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-sort"
          size="mini"
          @click="toggleExpandAll"
        >{{ $t('common.fold') }}</el-button>
      </el-col>
       <el-col :span="1.5">
            <el-button
              :loading="syncLoading"
              type="primary"
              icon="el-icon-refresh"
              size="mini"
              @click="handleSynchronism"
              v-hasPermi="['mes:md:mditem:edit']"
            >{{ $t('common.sync') }}</el-button>
          </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-if="refreshTable"
      v-loading="loading"
      :data="itemTypeList"
      row-key="itemTypeId"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column prop="itemTypeName" :label="$t('分类')" width="260"></el-table-column>
      <el-table-column prop="orderNum" :label="$t('排序')" width="200"></el-table-column>
      <el-table-column prop="itemOrProduct" :label="$t('物料/产品')" width="200">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.mes_item_product" :value="scope.row.itemOrProduct"/>
        </template>
      </el-table-column>
      
      <el-table-column prop="enableFlag" :label="$t('是否启用')" width="100">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.enableFlag"/>
        </template>
      </el-table-column>
      <el-table-column :label="$t('common.create_time')" align="center" prop="createTime" width="200">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('common.option')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:md:itemtype:edit']"
          >{{ $t('common.edit') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['mes:md:itemtype:add']"
          >{{ $t('common.add') }}</el-button>
          <el-button
            v-if="scope.row.parentTypeId != 0"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:md:itemtype:remove']"
          >{{ $t('common.del') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改物料分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="90px">      
        <el-row>
          <el-col :span="12" v-if="form.parentTypeId !== 0">
            <el-form-item :label="$t('父分类')" prop="parentTypeId">
              <treeselect v-model="form.parentTypeId" disabled = "disabled" :options="itemTypeOptions" :normalizer="normalizer" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('分类名称')" prop="itemTypeName">
              <el-input v-model="form.itemTypeName"  disabled = "disabled"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item :label="$t('显示排序')" prop="orderNum">
              <el-input-number v-model="form.orderNum" controls-position="right" :min="0" disabled = "disabled"/>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item :label="$t('最大合单数')" prop="maximumSingle">
              <el-input-number v-model="form.maximumSingle" controls-position="right" :min="0" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item :label="$t('最大米数')" prop="maximumMeters">
              <el-input-number v-model="form.maximumMeters" controls-position="right" :min="0" />
            </el-form-item>
          </el-col>
        </el-row>
        
        <el-row>
          <el-col :span="12">
            <el-form-item :label="$t('物料/产品')">
              <el-radio-group v-model="form.itemOrProduct">
                <el-radio
                  v-for="dict in dict.type.mes_item_product"
                  :key="dict.value"
                  :label="dict.value"
                >{{dict.label}}</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="$t('启用状态')">
              <el-radio-group v-model="form.enableFlag" disabled = "disabled">
                <el-radio
                  v-for="dict in dict.type.sys_yes_no"
                  :key="dict.value"
                  :label="dict.value"
                >{{dict.label}}</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('common.confirm') }}</el-button>
        <el-button @click="cancel">{{ $t('common.cancel') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>


import { listItemType, getItemType, delItemType, addItemType, updateItemType, listItemTypeExcludeChild ,synItemType} from "@/api/mes/md/itemtype";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "ItemType",
  dicts: ['sys_yes_no','mes_item_product'],
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 表格树数据
      itemTypeList: [],
      // 部门树选项
      itemTypeOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,

      syncLoading: false,
      // 查询参数
      queryParams: {
        itemTypeName: undefined,
        enableFlag: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        parentTypeId: [
          { required: true, message: this.$t('父分类不能为空'), trigger: "blur" }
        ],
        itemTypeName: [
          { required: true, message: this.$t('分类名称不能为空'), trigger: "blur" }
        ],
        orderNum: [
          { required: true, message: this.$t('显示排序不能为空'), trigger: "blur" }
        ],
        itemOrProduct: [
          {
            required: true,
            message: this.$t('请选择是产品分类还是物料分类'),
            trigger: ["blur"]
          }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询部门列表 */
    getList() {
      this.loading = true;
      listItemType(this.queryParams).then(response => {
        debugger;
        var types = this.handleTree(response.data, "itemTypeId","parentTypeId");
        this.itemTypeList = types;
        this.loading = false;
      });
    },
    /** 转换部门数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.itemTypeId,
        label: node.itemTypeName,
        children: node.children
      };
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        itemTypeId: undefined,
        parentTypeId: undefined,
        itemTypeCode: undefined,
        itemTypeName: undefined,
        orderNum: undefined,
        itemOrProduct: undefined,
        maximumSingle: undefined,
        maximumMeters: undefined,
        enableFlag: 'Y'
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      if (row != undefined) {
        this.form.parentTypeId = row.itemTypeId;
      }
      this.open = true;
      this.title = this.$t('添加分类');
      listItemType().then(response => {
        this.itemTypeOptions = this.handleTree(response.data, "itemTypeId","parentTypeId");
      });
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
        this.refreshTable = true;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      getItemType(row.itemTypeId).then(response => {
        this.form = response.data; 
        this.open = true;
        this.title = this.$t('修改分类');
      });
      listItemTypeExcludeChild(row.itemTypeId).then(response => {
        this.itemTypeOptions = this.handleTree(response.data, "itemTypeId","parentTypeId");
      });
    },
    /** 同步SAP */
    handleSynchronism() {
      this.syncLoading = true;
      this.reset();
      synItemType().then(res => {
        if(res.code === 200) {
          this.$modal.msgSuccess(this.$t('同步成功'));
         this.getList();
        }
        this.syncLoading = false;
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.itemTypeId != undefined) {
            updateItemType(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.edit_success'));
              this.open = false;
              this.getList();
            });
          } else {            
            addItemType(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.add_success'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm(this.$t('是否确认删除名称为"') + row.itemTypeName + this.$t('"的分类？')).then(function() {
        return delItemType(row.itemTypeId);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('common.del_success'));
      }).catch(() => {});
    }
  }
};
</script>
